/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 * Ӱͯ ̧
 *
 * ̧قӰɊ֘ASĂ̒`A^`A^錾܂݂܂B
 *
 * \par Application note:
 * AVR449: ATtiny261/461/861gp3ivӰ̐쓮
 *
 * \par Documentation
 * IȺގAxׁ߲A߲אݒAx޲ɂĂreadme.html
 * B
 *
 * \author
 * Atmel Corporation: http://www.atmel.com \n
 * xҰ: avr@atmel.com
 *
 * $Name$
 * $Revision: 2571 $
 * $RCSfile$
 * $Date: 2007-10-08 15:53:50 +0200 (ma, 08 okt 2007) $  \n
 ******************************************************************************/
#ifndef _PMSM_H_
#define _PMSM_H_

#include "stdint.h"

/*! \brief SӰ׸ނ̏W
 *
 * ̍\͖̂{ŎgpSĂӰ׸ނ܂݂܂B
 */
typedef struct PMSMflags
{
  uint8_t motorStopped : 1;			//! Ӱ~׸
  uint8_t motorSynchronized: 1;		//! Ӱ׸(motorStopped=TRUË͉Ӗ܂B)
  uint8_t actualDirection : 2;		//! ۂ̉]׸
  uint8_t desiredDirection : 1;		//! ]މ]׸
  uint8_t driveWaveform : 2;		//! ׂ݂̔g`׸(ԍ)
} PMSMflags_t;

#define FALSE			0			//! FALSE萔
#define TRUE			(!FALSE)	//! TRUE萔(rł̌݊ɑ΂Ē`)

#define CPU_FREQUENCY	16000000UL	//! CPUۯg(Hz)
#define DEAD_TIME		10			//! َ(/1 ۯ)

#ifndef PWM1X
/*! \brief TCCR1Bڼ޽PWM1X׸ނޯĈʒu
 *
 * TCCR1Bڼ޽PWM1X׸ނޯĈʒuBׂ߲ͯ ̧قŖ`߁A
 * ̧قɊ܂߂܂B
 */
#define PWM1X			7
#endif

#define UL				PB0			//! ULɐڑꂽ
#define UH				PB1			//! UHɐڑꂽ
#define VL				PB2			//! VLɐڑꂽ
#define VH				PB3			//! VHɐڑꂽ
#define WL				PB4			//! WLɐڑꂽ
#define WH				PB5			//! WHɐڑꂽ
//! ӰPWMo͂ɎgpS݂̎Օl
#define PWM_PIN_MASK_PORTB ((1 << UL) | (1 << UH) | (1 << VL) | (1 << VH) | (1 << WL) | (1 << WH))

#define H1_PIN			PA0			//! ΰيm1ڑ
#define H2_PIN			PA1			//! ΰيm2ڑ
#define H3_PIN			PA2			//! ΰيm3ڑ
//! ΰيmٱߋ/֎~(TRUE=,FALSE=֎~)
#define HALL_PULL_UP_ENABLE		FALSE
//#define HALL_PULL_UP_ENABLE	TRUE

#define DIRECTION_PIN	PA3			//! ͂ڑ

// ro͖ޯĒl
#define UL_OCOE			OC1OE0
#define UH_OCOE			OC1OE1
#define VL_OCOE			OC1OE2
#define VH_OCOE			OC1OE3
#define WL_OCOE			OC1OE4
#define WH_OCOE			OC1OE5

#define COMPARE_REGISTER_PHASE_U	OCR1A	//! Uprڼ޽
#define COMPARE_REGISTER_PHASE_V	OCR1B	//! Vprڼ޽
#define COMPARE_REGISTER_PHASE_W	OCR1D	//! Wprڼ޽

/*! \brief PWMo͔]I
 *
 * ̒`ł1ݒ/1PWMo͂𔽓]܂B]َ͒ԑ}
 * Ɍ܂B
 */
#define PWM_INVERT_OUTPUT	0
//#define PWM_INVERT_OUTPUT	1

#define DIRECTION_FORWARD	0	//! (])׸ޒl
#define DIRECTION_REVERSE	1	//! t(])׸ޒl
#define DIRECTION_UNKNOWN	3	//! s׸ޒl

/*! \brief ϒ\ɉ鑊̗vf
 *
 * ͊eɑ΂Ĕg`\̂Ɏgp鐳ϒ\ɉvfłB
 * ꂪׯ ؂Ɋi[ꂽsineTable̗vfƓłȂƂɒӂĂ
 * B
 */
#define SINE_TABLE_LENGTH			192U

/*! \eʁBgpׂ\IłB
 *
 *  \todo \eʂIłB
 */
#define SINE_TABLE_SIZE				SINE_TABLE_SIZE_LARGE	// 傫Ȑ\gp
//#define SINE_TABLE_SIZE			SINE_TABLE_SIZE_SMALL	// Ȑ\gp

#define SINE_TABLE_SIZE_LARGE		0		//! 傫Ȑ\(3~192vf)pSINE_TABLE_SIZEl
#define SINE_TABLE_SIZE_SMALL		1		//! Ȑ\(64vf)pSINE_TABLE_SIZEl

//! ϒ\ɉeɑ΂鐮(])iK̗vf
#define TABLE_ELEMENTS_PER_COMMUTATION_SECTOR	(SINE_TABLE_LENGTH / 6)

#define PWM_TOP_VALUE				0x03FF	//! /1̒(TOP)l

/*! Ӱ~ƌ􂳂̂ɐ旧āAǂΰيmωȂŐ(])'tick'
 *	߂Ȃ΂Ȃ܂B
 *
 *  \todo Ӱ~E␳ĂB
 */
#define COMMUTATION_TICKS_STOPPED	6000	// 6000~31.97s191.8msA52RPMȉŒ~Ɣ

/*! ̒萔̧ѳӰƓƌ􂷑OɕKvȐł̘A]
 *	ow肵܂Bł(SYNCHRONIZATION_COUNT+1)ΰيmωK
 *	vƂ܂B
 */
#define SYNCHRONIZATION_COUNT		2

#define WAVEFORM_BLOCK_COMMUTATION	0		//! ۯ(])pg`׸ޒ萔
#define WAVEFORM_SINUSOIDAL			1		//! 쓮pg`׸ޒ萔
#define WAVEFORM_BRAKING			2		//! ڰpg`׸ޒ萔
#define WAVEFORM_UNDEFINED			3		//! قȂ쓮`ԑJڂŎgpg`׸ޒ萔

#define BLOCK_COMMUTATION_DUTY_MULTIPLIER	3	//! ۯ(])ł̔rl(ޭè)̂߂̑x͊gW(0`255)

/*! ]BTURN_MODE_COAST܂TURN_MODE_BRAKÊǂ炩ɐݒ肵ĂB
 *
 *  \todo ]IłB
 */
//#define TURN_MODE					TURN_MODE_COAST		// ~
#define TURN_MODE					TURN_MODE_BRAKE		// ڰ~

#define TURN_MODE_COAST				0					//! Đ~pTURN_MODEl(쓮֎~)
#define TURN_MODE_BRAKE				1					//! ڰ~pTURN_MODEl(쓮GNDڑ)

/*! x`BSPEED_CONTROL_OPEN_LOOP܂SPEED_CONTROL_CLOSED_LOOP̂ǂ
 *	炩IłB
 *
 *  \todo x@IłB
 */
#define SPEED_CONTROL_METHOD		SPEED_CONTROL_OPEN_LOOP		// JHpxI
//#define SPEED_CONTROL_METHOD		SPEED_CONTROL_CLOSED_LOOP	// HpxI

#define SPEED_CONTROL_OPEN_LOOP		0							//! JHpxIl
#define SPEED_CONTROL_CLOSED_LOOP	1							//! HpxIl

/*! xߌJԂԂtick
 *  \todo xJԂԊ␳ĂB
 */
#define SPEED_CONTROLLER_TIME_BASE	150		// 150~31.97s4.8ms

/*! PIDᗘ萔
 *  \todo PIDᗘ␳ĂB(Ĥ)
 */
#define PID_K_P		256

/*! PIDϕ萔
 *  \todo PIDϕ␳ĂB(Ĥ)
 */
#define PID_K_I		10

/*! 萔
 *  \todo PID␳ĂB(Ĥ)
 */
#define PID_K_D		0

/*! ő呬xl͎ɐݒ_ƂĎgpő呝(ő呬x)
 *
 *  \todo ő呝(x䕔Ŏgpő呬x)␳ĂB
 */
#define SPEED_CONTROLLER_MAX_INCREMENT	620

/*! ő呬xl͊gW(x㏸̂ߏZȀꍇ͍ł߂
 *  2ׂ̂ɐ؂グ܂B
 *
 *  \todo ő呬xl͊gW␳ĂB
 */
#define SPEED_CONTROLLER_MAX_INPUT		1024		// W=102310241

// ֐^錾
static void SpeedController(uint16_t speedReference);
static void PortsInit(void);
static void PLLInit(void);
static void TimersInit(void);
static void PWMInit(void);
static void ADCInit(void);
static void PinChangeInit(void);
static void ExternalInterruptInit(void);
static void TimerSetModeBlockCommutation(void);
static void TimerSetModeSinusoidal(void);
static void TimerSetModeBrake(void);
static void BlockCommutationSetDuty(const uint16_t compareValue);
static uint8_t GetDesiredDirection(void);
static uint8_t GetActualDirection(void);
static void BlockCommutate(const uint8_t direction, const uint8_t hall);
static uint8_t GetHall(void);
static void DesiredDirectionUpdate(void);
static void ActualDirectionUpdate(uint8_t lastHall, const uint8_t newHall);
static uint16_t SineTableIncrementCalculate(const uint16_t ticks);
static void AdjustSineTableIndex(const uint16_t increment);
static void SetAdvanceCommutation(const uint8_t advanceCommutation);
static void EnablePWMOutputs(void);
static void DisablePWMOutputs(void);
static void CommutationTicksUpdate(void);
static void MotorSynchronizedUpdate(void);
static uint8_t IsMotorSynchronized(void);
static uint8_t SineTableSmallGetValue(uint8_t index);
static void SineOutputUpdate(void);
static unsigned int MultiplyUS15x8(const uint16_t m15, const uint8_t m8);

/*! \brief PWM6łޭè ِݒ
 *
 * ϸۂPWM6łޭè قݒ肵܂B
 */
#define TC1_PWM6_SET_DUTY_CYCLE(dutyCycle) TC1_WRITE_10_BIT_REGISTER(OCR1A, (dutyCycle))

#endif

